/* 
   $Id: IMPacket.c,v 1.4 2001/06/13 06:54:43 sho Exp $

   Copyright (C) 2001 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xproto.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlocale.h>

#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>

#include "IMProto.h"
#include "IMlib.h"
#include "default.h"

unsigned short	XimPcktGetCARD16( unsigned char *pckt )
{
  unsigned short	res;
  
  res = pckt[0] | (pckt[1]<<8);
  return res;
}


unsigned long	XimPcktGetCARD32( unsigned char *pckt )
{
  unsigned long		res;
  
  res  = pckt[0] | (pckt[1]<<8);
  res |= pckt[2]<<16;
  res |= pckt[3]<<24;
  return res;
}


int	XimPcktSetCARD16( unsigned char *buf, int data )
{
  buf[0] = data & 0xff;
  buf[1] = (data >> 8)&0xff;
  return 2;
}


int	XimPcktSetCARD32( unsigned char *buf, int data )
{
  buf[0] = data & 0xff;
  buf[1] = (data >> 8)&0xff;
  buf[2] = (data >> 16)&0xff;
  buf[3] = (data >> 24)&0xff;
  return 4;
}


int	XimPcktGetSTRING( unsigned char *pckt, XIMSTRING *ximstring )
{
  int	i, pad_len;
  
  i = 0;
  ximstring->len = XimPcktGetCARD16( pckt ); i += 2;
  ximstring->ptr = &( pckt[i] ); i += ximstring->len;
  pad_len = PADDING(ximstring->len);
  
  return i + pad_len;
}


int	XimPcktSetSTRING( unsigned char *pckt, XIMSTRING *ximstring )
{
  int	i, pad_len;
  
  i = 0;
  ximstring->len = strlen( ximstring->ptr );
  i += XimPcktSetCARD16( pckt, ximstring->len );
  memcpy( &(pckt[i]), ximstring->ptr, ximstring->len ); i += ximstring->len;
  pad_len = PADDING( ximstring->len + 2 );
  memset( &(pckt[i]), 0, pad_len ); i += pad_len;
  
  return i;
}


int	XimPcktGetSTR( unsigned char *pckt, XIMSTR *ximstr )
{
  int	i;

  i = 0;
  ximstr->len = pckt[0]; i++;
  ximstr->ptr = &( pckt[i] ); i += ximstr->len;
  return i;
}


int	XimPcktSetSTR( unsigned char *pckt, XIMSTR *ximstr )
{
  ximstr->len = strlen( ximstr->ptr );
  pckt[0] = ximstr->len;
  memcpy( &(pckt[1]), ximstr->ptr, pckt[0] );
  return 1 + pckt[0];
}


int	XimPcktGetXIMATTR( unsigned char *pckt, XIMATTR *ximattr )
{
  int	i, pad_len;
  
  i = 0;
  ximattr->ID = XimPcktGetCARD16( pckt ); i+=2;
  ximattr->TypeOfValue = XimPcktGetCARD16( &(pckt[2]) ); i+=2;
  ximattr->len = XimPcktGetCARD16( &(pckt[4]) ); i+=2;
  ximattr->ptr = &(pckt[6]); i += ximattr->len;
  pad_len = PADDING( ximattr->len +2 );
  return i + pad_len;
}


int	XimPcktSetXIMATTR( unsigned char *pckt, XIMATTR *ximattr )
{
  int	i, pad_len;

  i = 0;
  i += XimPcktSetCARD16( pckt, ximattr->ID );
  i += XimPcktSetCARD16( &(pckt[i]), ximattr->TypeOfValue );
  ximattr->len = strlen( ximattr->ptr );
  i += XimPcktSetCARD16( &(pckt[i]), ximattr->len );
  memcpy( &(pckt[i]), ximattr->ptr, ximattr->len ); i+=ximattr->len;
  pad_len = PADDING( ximattr->len +2 );
  memset( &(pckt[i]), 0, pad_len ); i+= pad_len;
  return i;
}


int	XimPcktGetXICATTR( unsigned char *pckt, XICATTR *xicattr )
{
  int	i, pad_len;
  
  i = 0;
  xicattr->ID = XimPcktGetCARD16( pckt ); i+=2;
  xicattr->TypeOfValue = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  xicattr->len = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  xicattr->ptr = &(pckt[i]); i += xicattr->len;
  pad_len = PADDING( xicattr->len +2 );
  return i + pad_len;
}
  

int	XimPcktSetXICATTR( unsigned char *pckt, XICATTR *xicattr )
{
  int	i, pad_len;

  i = 0;
  i += XimPcktSetCARD16( pckt, xicattr->ID );
  i += XimPcktSetCARD16( &(pckt[i]), xicattr->TypeOfValue );
  xicattr->len = strlen( xicattr->ptr );
  i += XimPcktSetCARD16( &(pckt[i]), xicattr->len );
  memcpy( &(pckt[i]), xicattr->ptr, xicattr->len ); i+=xicattr->len;
  pad_len = PADDING( xicattr->len +2 );
  memset( &(pckt[i]), 0, pad_len ); i+= pad_len;
  
  return i;
}


int	XimPcktGetXIMTRIGGERKEY( unsigned char *pckt, 
				 XIMTRIGGERKEY *ximtrigkey )
{
  ximtrigkey->keysym = XimPcktGetCARD32( pckt );
  ximtrigkey->modifier = XimPcktGetCARD32( &(pckt[4]) );
  ximtrigkey->modifier_mask = XimPcktGetCARD32( &(pckt[8]) );
  return 4 + 4 + 4;
}


int	XimPcktSetXIMTRIGGERKEY( unsigned char *pckt, 
				 XIMTRIGGERKEY *ximtrigkey )
{
  int	i;
  
  i = 0;
  i += XimPcktSetCARD32( pckt, ximtrigkey->keysym );
  i += XimPcktSetCARD32( &(pckt[i]), ximtrigkey->modifier );
  i += XimPcktSetCARD32( &(pckt[i]), ximtrigkey->modifier_mask );
  
  return i;
}


int	XimPcktGetENCODINGINFO( unsigned char *pckt, 
				XIMENCODINGINFO *ximencodinginfo )
{
  int	i, pad_len;
  
  i = 0;
  ximencodinginfo->len = XimPcktGetCARD16( pckt ); i+=2;
  ximencodinginfo->ptr = &(pckt[2]); i += ximencodinginfo->len;
  pad_len = PADDING( 2 + ximencodinginfo->len );
  return i + pad_len;
}


int	XimPcktSetENCODINGINFO( unsigned char *pckt, 
				XIMENCODINGINFO *ximencodinginfo )
{
  int	i, pad_len;
  
  i = 0;
  i += XimPcktSetCARD16( pckt, ximencodinginfo->len );
  ximencodinginfo->len = strlen( ximencodinginfo->ptr );
  memcpy( &(pckt[i]), ximencodinginfo->ptr, ximencodinginfo->len );
  i += ximencodinginfo->len;
  pad_len = PADDING( 2 + ximencodinginfo->len );
  memset( &(pckt[i]), 0, pad_len ); i+= pad_len;
  return i;
}





int	XimPcktGetXIMSTRCONVTEXT( unsigned char *pckt,
				  XIMSTRCONVTEXT *ximstrconvtext )
{
  int	i, pad_len;
  
  i = 0;
  ximstrconvtext->feedback = XimPcktGetCARD16( pckt ); i+=2;
  ximstrconvtext->len_str  = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  ximstrconvtext->str      = &(pckt[i]); i+=ximstrconvtext->len_str;
  pad_len = PADDING( ximstrconvtext->len_str ); i+=pad_len;
  ximstrconvtext->len_array= XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  i+=2;	// unused gap
  ximstrconvtext->array    = &(pckt[i]);
  i += ximstrconvtext->len_array;
  
  return i;
}



int	XimPcktSetXIMSTRCONVTEXT( unsigned char *pckt,
				  XIMSTRCONVTEXT *ximstrconvtext )
{
  int	i, pad_len;
  
  i = 0;
  i += XimPcktSetCARD16( pckt, ximstrconvtext->feedback );
  ximstrconvtext->len_str = strlen( ximstrconvtext->str );
  i += XimPcktSetCARD16( &(pckt[i]), ximstrconvtext->len_str );
  memcpy( &(pckt[i]), ximstrconvtext->str, ximstrconvtext->len_str );
  i += ximstrconvtext->len_str;
  pad_len = PADDING( ximstrconvtext->len_str ); i+=pad_len;
  i += XimPcktSetCARD16( &(pckt[i]), ximstrconvtext->len_array );
  pckt[i] = pckt[i+1] = 0; i+=2;
  memcpy( &(pckt[i]), ximstrconvtext->array, ximstrconvtext->len_array );
  i += ximstrconvtext->len_array;
  
  return i;
}




int	XimPcktGetXIMERROR( unsigned char *pckt, XIMERROR *ximerror )
{
  int	pad_len, i;
  
  i = 0;
  ximerror->imID = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  ximerror->icID = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  ximerror->flag = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  ximerror->err_code = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  ximerror->len  = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  ximerror->type = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  ximerror->detail = &(pckt[i]); i+= ximerror->len;
  pad_len = PADDING( ximerror->len );
  return i + pad_len;
}




int	XimPcktGetXIM_OPEN_REPLY( unsigned char *pckt, int *imID,
				  XIMATTR *ximattr, XICATTR *xicattr )
{
  int		i, j, n, l;
  int		len;
  
  i = 0;
  *imID = XimPcktGetCARD16( pckt ); i+=2;
  len  = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  for( n=j=0; j<len; n++ ){
    l = XimPcktGetXIMATTR( &(pckt[i]), &(ximattr[n]) );
    i += l; j += l;
  }
  len  = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  i += 2;
  
  for( n=j=0; j<len; n++ ){
    l = XimPcktGetXICATTR( &(pckt[i]), &(xicattr[n]) );
    i += l; j += l;
  }
  return i;
}



int	XimPcktGetXIM_REGISTER_TRIGGERKEYS( unsigned char *pckt, int *imID,
					    XIMTRIGGERKEY *onkey, 
					    XIMTRIGGERKEY *offkey )
{
  int		i, j, l, n;
  int		len;
  char		*keysym_str, *modif_str, *mask_str;
  
  i = 0;
  *imID = XimPcktGetCARD16( pckt ); i+=2;
  i+=2;	// unused
  len = XimPcktGetCARD32( &(pckt[i]) ); i+=4;
  
  for( j=n=0; j<len; n++ ){
    l = XimPcktGetXIMTRIGGERKEY( &(pckt[i]), &onkey[n] );
    i += l; j += l;
    keysym_str = XKeysymToString( onkey[n].keysym );
    modif_str = XKeysymToString( onkey[n].modifier );
    mask_str = XKeysymToString( onkey[n].modifier_mask );
  }
  len = XimPcktGetCARD32( &(pckt[i]) ); i+=4;
  for( j=n=0; j<len; n++ ){
    l = XimPcktGetXIMTRIGGERKEY( &(pckt[i]), &offkey[n] );
    i += l; j += l;
  }
  return i;
}



int	XimPcktGetXIM_QUERY_EXTENSION( unsigned char *pckt, int *imID )
{
  int		i, j, l, n;
  int		len;
  XIMSTR	ximstr[10];
  int pad_len;
  
  i = 0;
  *imID = XimPcktGetCARD16( pckt ); i+=2;
  len = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  for( j=n=0; j<len; n++ ){
    l = XimPcktGetSTR( &(pckt[i]), &(ximstr[n]) );
    i += l; j += l;
  }
  pad_len = PADDING(len);
  return	i+pad_len;
}



int	XimPcktGetXIM_ENCODING_NEGOTIATION( unsigned char *pckt, int *imID,
					    XIMSTR **ximstrp, int *ximstrlen,
					    XIMENCODINGINFO **ximencodinginfop, 
					    int *ximencodinginfolen )
{
  int			i, j, l, n,p;
  int			nlen, dlen, pad_len;
  XIMSTR		*ximstr,tmpimstr;
  XIMENCODINGINFO	*ximencodinginfo,tmpimenc;

  i = 0;
  *imID = XimPcktGetCARD16( pckt ); i+=2;
  nlen = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  p = i;
  for( j=n=0; j<nlen; n++ ){
    l = XimPcktGetSTR( &(pckt[i]), &tmpimstr );
    i += l; j += l;
  }
  i = p;
  *ximstrlen = n;
  *ximstrp = ximstr = (XIMSTR *)malloc( sizeof(XIMSTR)*n );
  for( j=n=0; j<nlen; n++ ){
    l = XimPcktGetSTR( &(pckt[i]), &(ximstr[n]));
    i += l; j += l;
  }
  pad_len = PADDING(nlen);
  i += pad_len;
  dlen = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  i += 2; 	// unused
  p = i;
  for( j=n=0; j<dlen; n++ ){
    l = XimPcktGetENCODINGINFO( &(pckt[i]), &tmpimenc );
    i += l; j += l;
  }
  i = p;
  *ximencodinginfolen = n;
  *ximencodinginfop = 
    ximencodinginfo = (XIMENCODINGINFO *)malloc( sizeof(XIMENCODINGINFO)*n );
  for( j=n=0; j<dlen; n++ ){
    l = XimPcktGetENCODINGINFO( &(pckt[i]), &(ximencodinginfo[n]) );
    i += l; j += l;
  }
  return	i;
}



int	XimPcktGetXICATTRIBUTE( unsigned char *pckt,
				XICATTRIBUTE *xicatr )
{
  int		i;
  int		len, pad_len;
  
  i = 0;
  xicatr->attrID = XimPcktGetCARD16( pckt ); i+=2;
  xicatr->len = len = XimPcktGetCARD16( &(pckt[i]) ); i+=2;
  xicatr->ptr = &(pckt[i]); i+=len;
  pad_len = PADDING( len );

  
#ifdef DEBUG_PRINT
  { int j;
  fprintf(stderr,"ID %3d:  len  %4d: ",
	 xicatr->attrID, len );
  for( j=0; j<len; j++ ){
    fprintf(stderr,"%02X ", xicatr->ptr[j] );
  }
  fprintf(stderr,"\n");
  }
#endif

  return	i + pad_len ;
}








