/* 
   $Id: nnmCommand.c,v 1.15 2001/07/30 07:22:03 sho Exp $

   Copyright (C) 2001 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "config.h"
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/List.h>
#include <X11/keysym.h>
#ifdef USE_XTEST  
#include <X11/extensions/XTest.h>
#endif

#include "./nnmUI.h"

#include "NnmProto.h"
#include "IMlib.h"

#define NNMDICMAN "nnmdicman"

#define KEYBOARD

#ifdef KEYBOARD

#ifdef KEYMAP_106
String key_label_list[] = {
  "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", 
  "q", "w", "e", "r", "t", "y", "u", "i", "o", "p", 
  "a", "s", "d", "f", "g", "h", "j", "k", "l", ";", 
  "z", "x", "c", "v", "b", "n", "m", ",", ".", "/",
  "-", "^", "\\", "@", " "," ", "[", ":", "]", "\\",
  NULL
};

String key_label_caps_list[] = {
  "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", 
  "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", 
  "A", "S", "D", "F", "G", "H", "J", "K", "L", ";", 
  "Z", "X", "C", "V", "B", "N", "M", ",", ".", "/",
  "-", "^", "\\", "@", " "," ", "[", ":", "]", "|",
  NULL
};

String key_label_shift[] = {
  "!", "\"", "#", "$", "%", "&", "\'", "(", ")", "~",
  "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", 
  "A", "S", "D", "F", "G", "H", "J", "K", "L", "+", 
  "Z", "X", "C", "V", "B", "N", "M", "<", ">", "?",
  "=", "~", "_", "`", " ", " ", "{", "*", "}", "|",
  NULL
};

unsigned int key_code[] = {
  XK_1, XK_2, XK_3, XK_4, XK_5, XK_6, XK_7, XK_8, XK_9, XK_0, 
  XK_q, XK_w, XK_e, XK_r, XK_t, XK_y, XK_u, XK_i, XK_o, XK_p, 
  XK_a, XK_s, XK_d, XK_f, XK_g, XK_h, XK_j, XK_k, XK_l, XK_semicolon, 
  XK_z, XK_x, XK_c, XK_v, XK_b, XK_n, XK_m, XK_comma , XK_period, XK_slash,
  XK_minus, XK_asciicircum, XK_backslash, XK_at, XK_space, XK_space, XK_bracketleft, XK_colon, XK_bracketright, XK_bar
};

#else
String key_label_list[] = {
  "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", 
  "q", "w", "e", "r", "t", "y", "u", "i", "o", "p", 
  "a", "s", "d", "f", "g", "h", "j", "k", "l", ";", 
  "z", "x", "c", "v", "b", "n", "m", ",", ".", "/",
  "-", "=", "[", "]", " ", " ", " ", "`", "'", "\\",
  NULL
};

String key_label_caps_list[] = {
  "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", 
  "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", 
  "A", "S", "D", "F", "G", "H", "J", "K", "L", ";", 
  "Z", "X", "C", "V", "B", "N", "M", ",", ".", "/",
  "-", "=", "[", "]", " ", " ", " ", "`", "'", "\\",
  NULL
};

String key_label_shift[] = {
  "!", "@", "#", "$", "%", "^", "&", "*", "(", ")",
  "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", 
  "A", "S", "D", "F", "G", "H", "J", "K", "L", ":", 
  "Z", "X", "C", "V", "B", "N", "M", "<", ">", "?",
  "_", "+", "{", "}", " ", " ", " ", "~", "\"", "|",
  NULL
};

unsigned int key_code[] = {
  XK_1, XK_2, XK_3, XK_4, XK_5, XK_6, XK_7, XK_8, XK_9, XK_0, 
  XK_q, XK_w, XK_e, XK_r, XK_t, XK_y, XK_u, XK_i, XK_o, XK_p, 
  XK_a, XK_s, XK_d, XK_f, XK_g, XK_h, XK_j, XK_k, XK_l, XK_semicolon, 
  XK_z, XK_x, XK_c, XK_v, XK_b, XK_n, XK_m, XK_comma , XK_period, XK_slash,
  XK_minus, XK_equal, XK_bracketleft, XK_bracketright, XK_space, XK_space, XK_space, XK_quoteleft,XK_quoteright, XK_backslash
};
#endif

String *key_label = key_label_list;

static Widget kbdForm;
static Widget kbdList;
static Widget kbdRETBtn, kbdShiftBtn, kbdCtrlBtn, kbdCapsBtn;

#define KIGOU_START 0x2100
#define KIGOU_END   0x7e00
#define KIGOU_COLUMN    8
#define KIGOU_RAW       4
#define KIGOU_DISP_MAX  32

static Widget kigouForm, kigouCommandForm;
static Widget kigouList;
static Widget kigouRETBtn;
static int    kigouPage = 0;

char    kigou_codes[KIGOU_DISP_MAX][3];
String  kigou_list[KIGOU_DISP_MAX + 1];

static Widget jisPopShell;
static Widget jisForm;
static Widget jisNumBtns[16];
static Widget jisCodeLabel;
static Widget jisCodeBtn;
static int    currentCode = 0;

#endif /* KEYBOARD */

static Boolean support_xtest = 0;

void    InitSendEventKey( Display *dpy)
{
#ifdef USE_XTEST  
  int event_base, error_base, major_version, minor_version;

  support_xtest = XTestQueryExtension(dpy, &event_base, &error_base, 
				      &major_version, &minor_version);

#ifdef DEBUG_PRINT
  if(support_xtest){
    fprintf(stderr, "event_base: %x\n", event_base);
    fprintf(stderr, "errot_base: %x\n", error_base);
    fprintf(stderr, "major_version: %x\n", major_version);
    fprintf(stderr, "minor_version: %x\n", minor_version);
  }
#endif
#endif /* USE_XTEST */
}

void	SendEventKey( Display *dpy, unsigned int keysym, unsigned int state)
{
  Window		sender;
  XEvent		ev;
  int                   j;

#ifdef DEBUG_PRINT
  fprintf(stderr," KeyPressEvent(keysym %3X:state %3X) --> ",
	 keysym, state );
#endif

  if(!support_xtest){
    XGetInputFocus(dpy, &sender, &j);
    ev.type = KeyPress;
    ev.xany.display= dpy;
    ev.xkey.window    = sender;
    ev.xkey.root      = DefaultRootWindow(dpy);
    ev.xkey.state     = state;
    ev.xkey.keycode   = XKeysymToKeycode(dpy, keysym);
    XSendEvent( dpy, sender, True, KeyPressMask,
		(XEvent *)&ev );
#ifdef DEBUG_PRINT
    fprintf(stderr, "Use XSendEvent\n");
#endif

#ifdef USE_XTEST
  }else{
    if(state & ShiftMask)
    	XTestFakeKeyEvent(dpy, XKeysymToKeycode(dpy, XK_Shift_L), True, 0);
    if(state & ControlMask)
    	XTestFakeKeyEvent(dpy, XKeysymToKeycode(dpy, XK_Control_L), True, 0);
    if(state & LockMask)
    	XTestFakeKeyEvent(dpy, XKeysymToKeycode(dpy, XK_Caps_Lock), True, 0);

    XTestFakeKeyEvent(dpy, XKeysymToKeycode(dpy, keysym), True, 0);

    if(state & ShiftMask)
    	XTestFakeKeyEvent(dpy, XKeysymToKeycode(dpy, XK_Shift_L), False, 0);
    if(state & ControlMask)
    	XTestFakeKeyEvent(dpy, XKeysymToKeycode(dpy, XK_Control_L), False, 0);
    if(state & LockMask)
    	XTestFakeKeyEvent(dpy, XKeysymToKeycode(dpy, XK_Caps_Lock), False, 0);
#ifdef DEBUG_PRINT
    fprintf(stderr, "Use XTestFakeKeyEvent\n");
#endif /* DEBUG_PRINT */
#endif /* USE_XTEST */
  }

#ifdef DEBUG_PRINT
  fprintf(stderr," Send XIM_FORWARD_EVENT");
  fprintf(stderr,"\n");
#endif
}

/*
 *  ǧButton WidgetCallbackؿ
 *
 */
static void	RecogBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
#ifdef WNN
  {
      extern int IsConv; 
      if(IsConv){
	RevConv();
      }
  }
#endif /* WNN */
  /* -1 ϼʸȤ̵Ȥ̣ */
  NnmRemoveTimeOut();
  NnmCurrentCanvasRecognize( -1, 1 );
}

#ifdef WNN
static void	ConvBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  NnmTransResult();
}
#endif /* WNN */

/*
 *  Popdown button widgetCallback
 */
#if 0
static void	PopdownBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmPopdown();
}
#endif

static void	RegBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
    char buf[4096];
    extern int serverPID;
    extern char *user_dictionary;

    sprintf(buf,"%s -p %d %s &", NNMDICMAN, serverPID, user_dictionary);
    system(buf);
}

static void	BSBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  NnmResultBackSpace();
}

static void	ESCBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  NnmResultESCKey();
}


static void	CRBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  NnmResultCRKey();
  XimSendKey( 0x000a );
}

static void	ENTBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  NnmResultCRKey();
}

static void	SPCBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
#ifdef WNN
  extern int IsConv;
  if(!IsConv)
#endif WNN
    NnmResultInsertChar( 0x0020 );
}

static void	KBDBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  MapKBDForm();
  UnmapTopForm();
  UnmapKigouForm();
}

static void	KigouBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  MapKigouForm();
  UnmapTopForm();
  UnmapKBDForm();
}

static Widget 	CreateButton( char *name, Widget parent)
{
  Arg		carg[10];
  int		i;
  Widget	w;

  i = 0;
  w = XtCreateManagedWidget( name, commandWidgetClass,
			     parent, carg, i );
  return w;
}


static Widget 	CreateToggle( char *name, Widget parent, 
			      Widget fromHoriz, Widget fromVert )
{
  Arg		carg[10];
  int		i;
  Widget	w;

  i = 0;
  w = XtCreateManagedWidget( name, toggleWidgetClass,
			     parent, carg, i );
  return w;
}

#if 0
#define NNM_TGL_NUM   1
#define NNM_TGL_KIGOU 2
#define NNM_TGL_KATA  4
#define NNM_TGL_HIRA  8
static int	TglState = 0;
#endif

/*
 *
 *
 */

Widget	CreateCommandWidgets( char *name, Widget parent, 
			      Arg args[], int num )
{
  Widget	CommandForm, w;
  Widget	RecogBtn;
  Widget	EscBtn, CRBtn, ENTBtn, SPCBtn, BSBtn, KBDBtn;
  Widget	KigouBtn, RegBtn;
#ifdef WNN
  Widget	ConvBtn;
#endif

  CommandForm = XtCreateManagedWidget( name, formWidgetClass,
				       parent, args, num );

  w = EscBtn = CreateButton( "esc", CommandForm);
  XtAddCallback( w, XtNcallback, ESCBtnProc, NULL );

  w = SPCBtn = CreateButton( "spc", CommandForm);
  XtAddCallback( w, XtNcallback, SPCBtnProc, NULL );

  w = CRBtn = CreateButton( "cr", CommandForm);
  XtAddCallback( w, XtNcallback, CRBtnProc, NULL );

  w = ENTBtn = CreateButton( "ent", CommandForm);
  XtAddCallback( w, XtNcallback, ENTBtnProc, NULL );

  w = RecogBtn = CreateButton( "recog", CommandForm);
  XtAddCallback( w, XtNcallback, RecogBtnProc, NULL );

#ifdef WNN
  w = ConvBtn = CreateButton( "conv", CommandForm );
  XtAddCallback( w, XtNcallback, ConvBtnProc, NULL );
#endif /* WNN */

  w = BSBtn = CreateButton( "bs", CommandForm );
  XtAddCallback( w, XtNcallback, BSBtnProc, NULL );

  w = RegBtn = CreateButton( "reg", CommandForm );
  XtAddCallback( w, XtNcallback, RegBtnProc, NULL );

#ifdef KEYBOARD 
  w = KBDBtn = CreateButton( "kbd", CommandForm );
  XtAddCallback( w, XtNcallback, KBDBtnProc, NULL );

  w = KigouBtn = CreateButton( "kigou", CommandForm);
  XtAddCallback( w, XtNcallback, KigouBtnProc, NULL );
#endif /* KEYBOARD */

  return CommandForm;
}

#ifdef KEYBOARD

static int IsShift = 0;
static int IsCtrl  = 0;
static int IsCaps  = 0;

void   kbdCRBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  SendEventKey( XtDisplay(w), XK_Return, 0);
}

void   kbdBSBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  SendEventKey( XtDisplay(w), XK_BackSpace, 0);
}

void   kbdDELBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  SendEventKey( XtDisplay(w), XK_Delete, 0);
}

void   kbdESCBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  SendEventKey( XtDisplay(w), XK_Escape, 0);
}

void   kbdRETBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  MapTopForm();
  UnmapKBDForm();
  UnmapKigouForm();
}

void   kbdCapsToggleProc( Widget w, XtPointer cli, XtPointer clo )
{
  if ( IsCaps == 1 ){
    IsCaps = 0;
    key_label = key_label_list;
  }else{
    IsCaps = 1;
    key_label = key_label_caps_list;
  }
  if (IsShift == 0) {
    XawListChange(kbdList, key_label, 50, 0, True);
  }
}

void   kbdShiftToggleProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg  args[10];
  int  num;

  if ( IsShift == 1 ){
    IsShift = 0;
    XawListChange(kbdList, key_label, 50, 0, True);
  }else{
    IsShift = 1;
    IsCtrl  = 0;
    XawListChange(kbdList, key_label_shift, 50, 0, True);

    num = 0;
    XtSetArg( args[num], XtNstate, 0); num++;  
    XtSetValues( kbdCtrlBtn, args, num);
  }
}

void   kbdCtrlToggleProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg  args[10];
  int  num;

  if ( IsCtrl == 1 ){
    IsCtrl = 0;
  }else{
    IsCtrl  = 1;

    if(IsShift){
      IsShift = 0;
      XawListChange(kbdList, key_label, 50, 0, True);
      num = 0;
      XtSetArg( args[num], XtNstate, 0); num++;  
      XtSetValues( kbdShiftBtn, args, num);
    }
  }
}

static void	kbdListProc( Widget w, XtPointer cli, XtPointer clo )
{
  XawListReturnStruct *list_return;
  int index;
  int num;
  Arg args[10];
  int mask;

  list_return = (XawListReturnStruct *) clo;
  index = list_return->list_index;
#ifdef DEBUG_PRINT
  fprintf(stderr,"string: %s\n", list_return->string);
  fprintf(stderr,"index: %d\n", list_return->list_index);
#endif

  mask = IsCaps == 1 ? LockMask : 0;
  if(index >= 0 && index < 50){
    if(IsShift){
      SendEventKey( XtDisplay(w), key_code[index], ShiftMask|mask);
      XawListChange(kbdList, key_label, 50, 0, True);
      
      num = 0;
      XtSetArg( args[num], XtNstate, 0); num++;  
      XtSetValues( kbdShiftBtn, args, num);
      
      IsShift = 0;
    }else if(IsCtrl){
      SendEventKey( XtDisplay(w), key_code[index], ControlMask|mask);

      num = 0;
      XtSetArg( args[num], XtNstate, 0); num++;  
      XtSetValues( kbdCtrlBtn, args, num);
      
      IsCtrl = 0;      
    }else{
      SendEventKey( XtDisplay(w), key_code[index], mask);
    }
  }
}

Widget	CreateKBDWidgets( char *name, Widget parent, 
			  Arg cargs[], int num )
{
  Arg		args[10];
  int		i;
  Widget        listForm,commandForm;
  Widget        kbdCRBtn, kbdBSBtn, kbdDELBtn, kbdESCBtn;


  kbdForm = XtCreateManagedWidget( name, formWidgetClass,
				   parent, cargs, num );

  num = 0;
  XtSetArg( args[num], XtNborderWidth, 0 ); num++;
  listForm = XtCreateManagedWidget( "listform", formWidgetClass,
				     kbdForm, args, num );
  num = 0;
  XtSetArg( args[num], XtNborderWidth, 0 ); num++;
  commandForm = XtCreateManagedWidget( "commandform", formWidgetClass,
				     kbdForm, args, num );

  i = 0;
  XtSetArg( args[i], XtNdefaultColumns, 10); i++;  
  XtSetArg( args[i], XtNlabel, "list" ); i++;
  XtSetArg( args[i], XtNlist, key_label ); i++;
  kbdList = XtCreateManagedWidget( "keyboard", listWidgetClass,
				   listForm, args, i );
  XtAddCallback( kbdList, XtNcallback, kbdListProc, NULL );
  
  i = 0;
  kbdShiftBtn = CreateToggle( "shift", commandForm, NULL, NULL );
  XtAddCallback( kbdShiftBtn, XtNcallback, kbdShiftToggleProc, (XtPointer)IsShift );

  i = 0;
  kbdCtrlBtn = CreateToggle( "ctrl",  commandForm, NULL, NULL );
  XtAddCallback( kbdCtrlBtn, XtNcallback, kbdCtrlToggleProc, (XtPointer) IsCtrl );

  i = 0;
  kbdCapsBtn = CreateToggle( "caps",  commandForm, NULL, NULL );
  XtAddCallback( kbdCapsBtn, XtNcallback, kbdCapsToggleProc, (XtPointer) IsCaps );

  i = 0;
  kbdCRBtn = XtCreateManagedWidget( "cr", commandWidgetClass,
				    commandForm, args,  i);
  XtAddCallback( kbdCRBtn, XtNcallback, kbdCRBtnProc, NULL );

  i = 0;
  kbdBSBtn = XtCreateManagedWidget( "bs", commandWidgetClass,
				    commandForm, args,  i);
  XtAddCallback( kbdBSBtn, XtNcallback, kbdBSBtnProc, NULL );

  i = 0;
  kbdDELBtn = XtCreateManagedWidget( "del", commandWidgetClass,
				    commandForm, args,  i);
  XtAddCallback( kbdDELBtn, XtNcallback, kbdDELBtnProc, NULL );

  i = 0;
  kbdESCBtn = XtCreateManagedWidget( "esc", commandWidgetClass,
				    commandForm, args,  i);
  XtAddCallback( kbdESCBtn, XtNcallback, kbdESCBtnProc, NULL );

  i = 0;
  kbdRETBtn = XtCreateManagedWidget( "return", commandWidgetClass,
				    commandForm, args,  i);
  XtAddCallback( kbdRETBtn, XtNcallback, kbdRETBtnProc, NULL );

  return kbdForm;
}

void   kigouNextBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg  args[10];
  int  i;
  char s[256];

  kigouPage += 0x20;

  if((kigouPage & 0xff) >= 0x80) kigouPage = (kigouPage & 0xff00) + 0x100;
  if((kigouPage & 0xff) <= 0x20) kigouPage = (kigouPage & 0xff00) + 0x20;

  if((KIGOU_START + kigouPage) > 0x7e60) kigouPage = 0x7e60 - KIGOU_START;

  for( i = 0; i < KIGOU_DISP_MAX; i++){
    kigou_codes[i][0] = ((KIGOU_START + kigouPage + i) >> 8) | 0x80;
    kigou_codes[i][1] = ((KIGOU_START + kigouPage + i) & 0xff)| 0x80;
    kigou_codes[i][2] = '\0';
    kigou_list[i] = kigou_codes[i];
  }
  kigou_list[i] = NULL;
  XawListChange(kigouList, kigou_list, i, 0, True);

  sprintf(s, "%04x", kigouPage + KIGOU_START);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeBtn, args, i);

}

void   kigouPrevBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg  args[10];
  int  i;
  char s[256];

  kigouPage -= 0x20;

  if(kigouPage < 0x20){
    kigouPage = 0x20;
    return;
  }

  if((kigouPage & 0xff) >= 0x80 || ((kigouPage & 0xff)== 0))    
    kigouPage = (kigouPage & 0xff00) - 0xa0;
  else if((kigouPage & 0xff) < 0x20)       kigouPage = (kigouPage & 0xff00) - 0x80;

  for( i = 0; i < 0x20; i++){
    kigou_codes[i][0] = ((KIGOU_START + kigouPage + i) >> 8) | 0x80;
    kigou_codes[i][1] = ((KIGOU_START + kigouPage + i) & 0xff)| 0x80;
    kigou_codes[i][2] = '\0';
    kigou_list[i] = kigou_codes[i];
  }
  kigou_list[i] = NULL;
  XawListChange(kigouList, kigou_list, i, 0, True);

  sprintf(s, "%04x", kigouPage + KIGOU_START);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeBtn, args, i);

}

void   kigouRETBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  MapTopForm();
  UnmapKBDForm();
  UnmapKigouForm();
}

static void	kigouListProc( Widget w, XtPointer cli, XtPointer clo )
{
  XawListReturnStruct *list_return;
  int index;

  list_return = (XawListReturnStruct *) clo;
  index = list_return->list_index;
  XimSendString(list_return->string);
}

void NnmSetJisCodeBtnLabel(int code)
{
  Arg        args[10];
  int        i;
  char       s[256];

  while( (code != 0) && (code < 0xfff)) code <<=4;

  sprintf(s, "%04x", code);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeBtn, args, i);
}

static void NnmSetJisCodeLabelLabel(int code)
{
  Arg        args[10];
  int        i;
  char       s[256];

  while( (code != 0) && (code < 0xfff)) code <<=4;

  sprintf(s, "%04x", code);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeLabel, args, i);
}

static void  jisNumBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  int        i, j, idx;
  char       s[256];

  idx = (int)cli;

  if( (currentCode > 0xff) && (currentCode < 0xfff) ) {
    currentCode <<= 4;
    currentCode += idx;

    s[0] = (currentCode & 0xff) | 0x80;
    s[1] = (currentCode >> 8)   | 0x80;
    s[2] = 0;
    XimSendString(s);

    currentCode = 0;
    NnmSetJisCodeBtnLabel(currentCode);
    NnmSetJisCodeLabelLabel(currentCode);

  }else if( (currentCode > 0xf) && (currentCode < 0xff) ) {
    currentCode <<= 4;
    currentCode += idx;

    kigouPage = ((currentCode << 4)& 0xffe0)- KIGOU_START;

    if(kigouPage < 0)
      currentCode = KIGOU_START >> 4, kigouPage = 0;
    else if(kigouPage > KIGOU_END - KIGOU_START)
      currentCode = KIGOU_END >> 4, kigouPage = KIGOU_END - KIGOU_START;

    if((kigouPage & 0xff) <= 0x20) kigouPage = (kigouPage & 0xff00) + 0x20;
    if((kigouPage & 0xff) >= 0x80) kigouPage = (kigouPage & 0xff00) + 0x120;

    for( i = j = 0; i < 0x20; i++,j++){
      kigou_codes[i][0] = ((KIGOU_START + kigouPage + j) >> 8)  | 0x80;
      kigou_codes[i][1] = ((KIGOU_START + kigouPage + j) & 0xff)| 0x80;
      kigou_codes[i][2] = '\0';
      kigou_list[i] = kigou_codes[i];
    }
    kigou_list[i] = NULL;
    XawListChange(kigouList, kigou_list, i, 0, True);

    NnmSetJisCodeBtnLabel(kigouPage + KIGOU_START);
    NnmSetJisCodeLabelLabel(currentCode);
  }else{
    currentCode <<= 4;
    currentCode += idx;
    NnmSetJisCodeBtnLabel(currentCode);
    NnmSetJisCodeLabelLabel(currentCode);
  }

}

static void  jisBSBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  currentCode >>= 4;
  NnmSetJisCodeBtnLabel(currentCode);
  NnmSetJisCodeLabelLabel(currentCode);
}

static void  jisCloseBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  XtPopdown(jisPopShell);
}


void	NnmCreateJISPopup( Widget top )
{
  Arg		args[10];
  int		i, num;
  Widget        bsBtn,closeBtn;

  jisPopShell = XtCreatePopupShell( "jisshell",
				      overrideShellWidgetClass,
				      top, NULL, 0 );
  jisForm = XtCreateManagedWidget( "jisform", formWidgetClass,
				   jisPopShell, NULL, 0 );

  num = 0;
  jisCodeLabel = XtCreateManagedWidget( "label", labelWidgetClass,
					jisForm, args, num );

  num = 0;
  XtSetArg( args[num], XtNfromVert, jisCodeLabel ); num++;
  XtSetArg( args[num], XtNfromHoriz, NULL ); num++;
  XtSetArg( args[num], XtNborderWidth, 1 ); num++;
  XtSetArg( args[num], XtNinternational, True ); num++;
  
  for( i = 0; i < 16; i++ ){
    char tmp[2048];
    char *table[] = { "0", "1", "2", "3", "4", "5", "6", "7",
		      "8", "9", "A", "B", "C", "D", "E", "F" };    

    sprintf( tmp, "%s", table[i]);
    jisNumBtns[i] = XtCreateManagedWidget( tmp, commandWidgetClass,
					jisForm, args, num );

    XtAddCallback( jisNumBtns[i], XtNcallback, jisNumBtnProc,
		   (XtPointer) i);
    
    
    if((i & 0x3) == 3){
      XtSetArg( args[0], XtNfromVert, jisNumBtns[ i & 0x0c] );
      XtSetArg( args[1], XtNfromHoriz, NULL );
    }
    else{
      XtSetArg( args[1], XtNfromHoriz, jisNumBtns[i] );
    }
  }

  num = 0;
  XtSetArg( args[num], XtNfromVert, jisNumBtns[12] ); num++;
  XtSetArg( args[num], XtNfromHoriz, NULL ); num++;
  bsBtn = XtCreateManagedWidget( "bs", commandWidgetClass,
				     jisForm, args, num);
  
  XtAddCallback( bsBtn, XtNcallback, jisBSBtnProc, NULL);

  num = 0;
  XtSetArg( args[num], XtNfromVert, jisNumBtns[12] ); num++;
  XtSetArg( args[num], XtNfromHoriz, bsBtn ); num++;
  closeBtn = XtCreateManagedWidget( "close", commandWidgetClass,
				     jisForm, args,  num);
  XtAddCallback( closeBtn, XtNcallback, jisCloseBtnProc, NULL );

}

void   jisCodeBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg args[10];
  int x, y, width, height;
  int wx, wy;

  x = 0, y = 0, width = 0, height = 0;
  wx = 0, wy = 0;

  NnmGetWindowPos(w, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetWindowPos(kigouCommandForm, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetWindowPos(kigouForm, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetShellPos(&x, &y, &width, &height);
  wx += x, wy += y;

  currentCode = 0;
  NnmSetJisCodeLabelLabel(currentCode);

  XtSetArg( args[0], XtNx, wx );
  XtSetArg( args[1], XtNy, wy );
  XtSetValues( jisPopShell, args, 2 );

  XtPopup(jisPopShell, XtGrabNonexclusive );
}

Widget	CreateKigouWidgets( char *name, Widget parent, 
			      Arg cargs[], int num )
{
  Arg		args[10];
  int		i, j;
  Widget        kigouNextBtn, kigouPrevBtn;
  Widget        listForm, commandForm;
  char          s[256];

  kigouForm = XtCreateManagedWidget( name, formWidgetClass,
				     parent, cargs, num );

  num = 0;
  XtSetArg( args[num], XtNborderWidth, 0 ); num++;
  listForm = XtCreateManagedWidget( "listform", formWidgetClass,
				     kigouForm, args, num );

  num = 0;
  XtSetArg( args[num], XtNborderWidth, 0 ); num++;
  commandForm = XtCreateManagedWidget( "commandform", formWidgetClass,
				     kigouForm, args, num );
  kigouCommandForm = commandForm;

  kigouPage = 0x20;
  for( i = j = 0; i < KIGOU_DISP_MAX; i++,j++){
    kigou_codes[i][0] = ((KIGOU_START + kigouPage + j) >> 8) | 0x80;
    kigou_codes[i][1] = ((KIGOU_START + kigouPage + j) & 0xff)| 0x80;
    kigou_codes[i][2] = '\0';
    kigou_list[i] = kigou_codes[i];    
  }
  kigou_list[KIGOU_DISP_MAX] = NULL;

  i = 0;
  XtSetArg( args[i], XtNdefaultColumns, KIGOU_COLUMN); i++;  
  XtSetArg( args[i], XtNlabel, "list" ); i++;
  XtSetArg( args[i], XtNlist, kigou_list ); i++;
  kigouList = XtCreateManagedWidget( "list", listWidgetClass,
				   listForm, args, i );
  XtAddCallback( kigouList, XtNcallback, kigouListProc, NULL );

  i = 0;
  sprintf(s, "%04x", kigouPage + KIGOU_START);
  XtSetArg( args[i], XtNlabel, s); i++; 
  jisCodeBtn = XtCreateManagedWidget( "code", commandWidgetClass,
				       commandForm, args,  i);
  XtAddCallback( jisCodeBtn, XtNcallback, jisCodeBtnProc, NULL );
  
  i = 0;
  kigouPrevBtn = XtCreateManagedWidget( "prev", commandWidgetClass,
					commandForm, args,  i);
  XtAddCallback( kigouPrevBtn, XtNcallback, kigouPrevBtnProc, NULL );

  i = 0;
  kigouNextBtn = XtCreateManagedWidget( "next", commandWidgetClass,
					commandForm, args,  i);
  XtAddCallback( kigouNextBtn, XtNcallback, kigouNextBtnProc, NULL );

  i = 0;
  kigouRETBtn = XtCreateManagedWidget( "return", commandWidgetClass,
				       commandForm, args,  i);
  XtAddCallback( kigouRETBtn, XtNcallback, kigouRETBtnProc, NULL );
  return kigouForm; 
}
#endif /* KEYBOARD */
